dofile_once("mods/koira/files/scripts/utilities.lua")
dofile_once("data/scripts/lib/utilities.lua")


function do_money_drop(not_really)
  -- Nothing.
  -- This is a quick way to globally block any gold drops.
  --
  -- TODO: Maybe just *not call* this script in the future,
  --       once we have all the enemies in our pocket.
end


function increment_killcount(player)
  local wallet = EntityGetFirstComponent(player, "WalletComponent")
  local money = ComponentGetValueInt(wallet, "money")

  ComponentSetValue(wallet, "money", money+1)
end


-- TODO: Move this elsewhere
function increment_rage(player)
  local bottledRage = EntityGetWithName("BOTTLED_FEELINGS")
  if bottledRage == nil then
    -- No bottle found, abort.
    return
  end

  local allMaterials = EntityGetValue(
    bottledRage, "MaterialInventoryComponent", "count_per_material_type"
  )

  -- TODO: Kinda ugly way to fetch a material. But we're "pretty" sure there
  -- shouldn't be any other materials in there.
  local count = 0
  for k, v in pairs(allMaterials) do
    if v > 0 then
      count = v
    end
  end

  local newTotal = count + 1

  -- TODO: Get rid of the hardcoding
  local barrelSize = EntityGetValue(
    bottledRage, "MaterialSuckerComponent", "barrel_size"
  )

  if newTotal <= barrelSize then
    AddMaterialInventoryMaterial(bottledRage, "liquid_hatred", newTotal)
  else
    local hatred = CellFactory_GetType("liquid_hatred")
    EntityIngestMaterial(player, hatred, barrelSize)

    GamePrintImportant("$koira_blinded_by_rage", "")
    -- Reset to 1, so we don't get the ugly "0" prompt ontop of the item.
    AddMaterialInventoryMaterial(bottledRage, "liquid_hatred", 1)
  end
end


function death(damage_type_bit_field, damage_message, responsible_entity, drop_items)
  if (IsPlayer(responsible_entity)) then
    -- Yeah we're counting kills, not some puny *gold*.
    increment_killcount(responsible_entity)

    -- Very special "rage" feature
    increment_rage(responsible_entity)
  end
end
