dofile_once("mods/koira/files/scripts/utilities.lua")

function add_mod_projectile(path)
  add_projectile(MOD_PATH .. path)
end

table.insert( actions,
{
  id                = "PUNCH",
  name              = "Swoosh",
  description       = "You swing your fists, what do you think happens?",
  sprite            = MOD_PATH .. "weapons/fists/projectile/magazine.png",
  type              = ACTION_TYPE_PROJECTILE,
  spawn_level       = "0,4,5,6",
  spawn_probability = "1,1,1,1",
  price             = 600,
  mana              = 0,
  custom_xml_file = "mods/koira/files/weapons/permanent_magazine.xml",
  action = function()
    add_mod_projectile("weapons/fists/projectile/entity.xml")
  end,
})

table.insert( actions,
{
  id                = "STAB",
  name              = "$koira_stab",
  description       = "$koira_stab_desc",
  sprite            = MOD_PATH .. "weapons/knife/projectile/magazine.png",
  type              = ACTION_TYPE_PROJECTILE,
  spawn_level       = "0,4,5,6",
  spawn_probability = "1,1,1,1",
  price             = 600,
  mana              = 0,
  max_uses          = -1,
  custom_xml_file = "mods/koira/files/weapons/permanent_magazine.xml",
  action = function()
    add_mod_projectile("weapons/knife/projectile/entity.xml")
  end,
})

table.insert( actions,
{
  id                = "SPEAR_POKE",
  name              = "Stab",
  description       = "Basically a knife with a longer handle",
  sprite            = MOD_PATH .. "weapons/spear/projectile/magazine.png",
  type              = ACTION_TYPE_PROJECTILE,
  spawn_level       = "0,4,5,6",
  spawn_probability = "1,1,1,1",
  price             = 600,
  mana              = 0,
  max_uses          = -1,
  custom_xml_file = "mods/koira/files/weapons/permanent_magazine.xml",
  action = function()
    add_mod_projectile("weapons/spear/projectile/entity.xml")
  end,
})

table.insert( actions,
{
  id                = "SHOTGUNSHELL",
  name              = "Shotgun Shells",
  description       = "Bandolier of 12 Gauge Shotgun Shells",
  sprite            = MOD_PATH .. "weapons/shotgun/projectile/shotgunshell.png",
  type              = ACTION_TYPE_PROJECTILE,
  spawn_level       = "0,4,5,6",
  spawn_probability = "1,1,1,1",
  price             = 600,
  mana              = 0,
  max_uses          = 6,
  custom_xml_file = "mods/koira/files/weapons/magazine.xml",
  action = function()
    add_mod_projectile("weapons/shotgun/projectile/entity.xml")
    add_mod_projectile("weapons/shotgun/projectile/entity_silent.xml")
    add_mod_projectile("weapons/shotgun/projectile/entity_silent.xml")
    add_mod_projectile("weapons/shotgun/projectile/entity_silent.xml")
    add_mod_projectile("weapons/shotgun/projectile/entity_silent.xml")
    shot_effects.recoil_knockback = shot_effects.recoil_knockback + 5
    c.spread_degrees = 4
    c.damage_critical_chance = 0
  end,
})

table.insert( actions,
{
  id                = "PISTOL_CLIP",
  name              = "Pistol Magazine",
  description       = "Standard issue magazine",
  sprite            = MOD_PATH .. "weapons/pistol/projectile/magazine.png",
  type              = ACTION_TYPE_PROJECTILE,
  spawn_level       = "0,4,5,6",
  spawn_probability = "1,1,1,1",
  price             = 600,
  mana              = 0,
  max_uses          = 12,
  custom_xml_file = "mods/koira/files/weapons/magazine.xml",
  action = function()
    add_mod_projectile("weapons/pistol/projectile/entity.xml")
    c.damage_critical_chance = 0
  end,
})

table.insert( actions,
{
  id                = "REVOLVER_AMMO",
  name              = "Revolver Speedloader",
  description       = "Standard six-chamber revolver speedloader",
  sprite            = MOD_PATH .. "weapons/revolver/projectile/magazine.png",
  type              = ACTION_TYPE_PROJECTILE,
  spawn_level       = "0,4,5,6",
  spawn_probability = "1,1,1,1",
  price             = 600,
  mana              = 0,
  max_uses          = 6,
  custom_xml_file = "mods/koira/files/weapons/magazine.xml",
  action = function()
    add_mod_projectile("weapons/revolver/projectile/entity.xml")
    c.damage_critical_chance = 0
  end,
})

table.insert( actions,
{
  id                = "SMG_CLIP",
  name              = "SMG Magazine",
  description       = "Wow, that's a lot of bullets",
  sprite            = MOD_PATH .. "weapons/smg/projectile/magazine.png",
  type              = ACTION_TYPE_PROJECTILE,
  spawn_level       = "0,4,5,6",
  spawn_probability = "1,1,1,1",
  price             = 600,
  mana              = 5,
  max_uses          = 50,
  custom_xml_file = "mods/koira/files/weapons/magazine.xml",
  sound_loop_tag = "sound_chainsaw",
  action = function()
    add_mod_projectile("weapons/smg/projectile/entity.xml")
    c.damage_critical_chance = 0
  end,
})

table.insert( actions,
{
  id                = "AR_CLIP",
  name              = "Assault Rifle Magazine",
  description       = "Standard issue magazine",
  sprite            = MOD_PATH .. "weapons/assault_rifle/projectile/magazine.png",
  type              = ACTION_TYPE_PROJECTILE,
  spawn_level       = "0,4,5,6",
  spawn_probability = "1,1,1,1",
  price             = 600,
  mana              = 0,
  max_uses          = 30,
  custom_xml_file = "mods/koira/files/weapons/magazine.xml",
  action = function()
    add_mod_projectile("weapons/assault_rifle/projectile/entity.xml")
    c.damage_critical_chance = 0
  end,
})

table.insert( actions,
{
  id                = "RIFLE_CLIP",
  name              = "Rifle Magazine",
  description       = "Standard issue stripper clip",
  sprite            = MOD_PATH .. "weapons/rifle/projectile/magazine.png",
  type              = ACTION_TYPE_PROJECTILE,
  spawn_level       = "0,4,5,6",
  spawn_probability = "1,1,1,1",
  price             = 600,
  mana              = 0,
  max_uses          = 5,
  custom_xml_file = "mods/koira/files/weapons/magazine.xml",
  action = function()
    add_mod_projectile("weapons/rifle/projectile/entity.xml")
    c.damage_critical_chance = 0
  end,
})

table.insert( actions,
{
  -- TODO: Jerry-can, Duh!
  id                = "CHAINSAW_CANISTER",
  name              = "Chainsaw Canister",
  description       = "A canister of gasoline for the chainsaw",
  sprite            = MOD_PATH .. "weapons/flammenwerfer/projectile/canister.png",
  type              = ACTION_TYPE_PROJECTILE,
  spawn_level       = "0,4,5,6",
  spawn_probability = "1,1,1,1",
  price             = 600,
  mana              = 0,
  max_uses          = 200,
  custom_xml_file = "mods/koira/files/weapons/magazine.xml",
  sound_loop_tag = "sound_chainsaw",
  action = function()
    add_mod_projectile("weapons/chainsaw/projectile/entity.xml")
    c.damage_critical_chance = 0
  end,
})

table.insert( actions,
{
  id                = "FMW_CANISTER",
  name              = "Gas Canister",
  description       = "A canister of gasoline for the flammenwerfer",
  sprite            = MOD_PATH .. "weapons/flammenwerfer/projectile/canister.png",
  type              = ACTION_TYPE_PROJECTILE,
  spawn_level       = "0,4,5,6",
  spawn_probability = "1,1,1,1",
  price             = 600,
  mana              = 0,
  max_uses          = 616,
  custom_xml_file = "mods/koira/files/weapons/magazine.xml",
--  TODO: A proper torch, this is too much: "data/entities/misc/custom_cards/torch.xml",
  action = function()
    -- This plays a big part in having sufficiently variable flame
    local start = MOD_PATH .. "weapons/flammenwerfer/projectile/entity_start.xml"
    local ending = MOD_PATH .. "weapons/flammenwerfer/projectile/entity_end.xml"
    add_projectile_trigger_timer(start, 8, 1, ending)
    add_projectile_trigger_timer(start, 15, 1, ending)
    add_projectile_trigger_timer(start, 17, 1, ending)
    c.damage_critical_chance = 0
  end,
})

table.insert( actions,
{
  id                = "ROCKET_MAG",
  name              = "Rocket Magazine",
  description       = "These look dangerous...",
  sprite            = MOD_PATH .. "weapons/rocket_launcher/projectile/magazine.png",
  type              = ACTION_TYPE_PROJECTILE,
  spawn_level       = "0,4,5,6",
  spawn_probability = "1,1,1,1",
  price             = 600,
  mana              = 0,
  max_uses          = 8,
  custom_xml_file = "mods/koira/files/weapons/magazine.xml",
  action = function()
    add_mod_projectile("weapons/rocket_launcher/projectile/entity.xml")
    c.damage_critical_chance = 0
  end,
})

table.insert( actions,
{
  id                = "STAKE_BUNDLE",
  name              = "Bundle of Stakes",
  description       = "These things are the size of your arm... bigger even",
  sprite            = MOD_PATH .. "weapons/stakegun/projectile/magazine.png",
  type              = ACTION_TYPE_PROJECTILE,
  spawn_level       = "0,4,5,6",
  spawn_probability = "1,1,1,1",
  price             = 600,
  mana              = 0,
  max_uses          = 7,
  custom_xml_file = "mods/koira/files/weapons/magazine.xml",
  action = function()
    add_mod_projectile("weapons/stakegun/projectile/entity.xml")
    c.damage_critical_chance = 0
  end,
})

table.insert( actions,
{
  id                = "GRENADE_BELT",
  name              = "Grenade Belt",
  description       = "Ammunition for your grenade launcher",
  sprite            = MOD_PATH .. "weapons/grenade_launcher/projectile/magazine.png",
  type              = ACTION_TYPE_PROJECTILE,
  spawn_level       = "0,4,5,6",
  spawn_probability = "1,1,1,1",
  price             = 600,
  mana              = 0,
  max_uses          = 5,
  custom_xml_file = "mods/koira/files/weapons/magazine.xml",
  action = function()
    add_mod_projectile("weapons/grenade_launcher/projectile/entity.xml")
    c.damage_critical_chance = 0
  end,
})

table.insert( actions,
{
  id                = "BOLT_BATTERY",
  name              = "Railgun battery",
  description       = "Fits nicely into your railgun",
  sprite            = MOD_PATH .. "weapons/railgun/projectile/magazine.png",
  type              = ACTION_TYPE_PROJECTILE,
  spawn_level       = "0,4,5,6",
  spawn_probability = "1,1,1,1",
  price             = 600,
  mana              = 65,
  max_uses          = 15,
  custom_xml_file = "mods/koira/files/weapons/magazine.xml",
  action = function()
    add_mod_projectile("weapons/railgun/projectile/entity.xml")

    -- A special (hax) effect of turning the trail behind our main projectile into ash
    add_mod_projectile("weapons/railgun/projectile/ground_to_ash.xml")
    add_mod_projectile("weapons/railgun/projectile/ground_to_ash2.xml")
    add_mod_projectile("weapons/railgun/projectile/ground_to_ash3.xml")

    c.damage_critical_chance = 0
    shot_effects.recoil_knockback = 90.0
  end,
})

table.insert( actions,
{
  id                = "PLASMA_CELL",
  name              = "Plasmagun cell",
  description       = "A swirl of magical colors in a glass-metal casing",
  sprite            = MOD_PATH .. "weapons/plasmagun/projectile/magazine.png",
  type              = ACTION_TYPE_PROJECTILE,
  spawn_level       = "0,4,5,6",
  spawn_probability = "1,1,1,1",
  price             = 600,
  mana              = 10,
  max_uses          = 75,
  custom_xml_file = "mods/koira/files/weapons/magazine.xml",
  action = function()
    add_mod_projectile("weapons/plasmagun/projectile/entity.xml")
    c.damage_critical_chance = 0
  end,
})

table.insert( actions,
{
  id                = "MACHINEGUN_CELL",
  name              = "Machinegun cell",
  description       = "Rapid fire ammunition for your Machine Gun",
  sprite            = MOD_PATH .. "weapons/machinegun/projectile/magazine.png",
  type              = ACTION_TYPE_PROJECTILE,
  spawn_level       = "0,4,5,6",
  spawn_probability = "1,1,1,1",
  price             = 600,
  mana              = 0,
  max_uses          = 400,
  custom_xml_file = "mods/koira/files/weapons/magazine.xml",
  action = function()
    add_mod_projectile("weapons/machinegun/projectile/entity.xml")
    c.damage_critical_chance = 0
  end,
})

table.insert( actions,
{
  id                = "LIGHTNING_BATTERY",
  name              = "Lightning Battery",
  description       = "Ammunition for your lightning gun",
  sprite            = "data/ui_gfx/gun_actions/lightning.png",
  type              = ACTION_TYPE_PROJECTILE,
  spawn_level       = "0,4,5,6",
  spawn_probability = "1,1,1,1",
  price             = 600,
  mana              = 0,
  max_uses          = 6,
  custom_xml_file = "mods/koira/files/weapons/magazine.xml",
  action = function()
    add_projectile("data/entities/projectiles/deck/lightning.xml")
    c.fire_rate_wait = c.fire_rate_wait + 50
    shot_effects.recoil_knockback = 180.0
  end,
})

table.insert( actions,
{
  id                = "WIND_BLAST",
  name              = "Wind blast",
  description       = "A strong blast of the wind",
  sprite            = "data/ui_gfx/gun_actions/air_bullet.png",
  type              = ACTION_TYPE_PROJECTILE,
  spawn_level       = "2,3,4,5,6",
  spawn_probability = "1,1,1,1,1",
  price             = 150,
  mana              = 0,
  max_uses          = 100,
  custom_xml_file = "mods/koira/files/weapons/magazine.xml",
  action = function()
    -- TODO: Physical object push effect
    add_mod_projectile( "weapons/air_blaster/projectile/entity.xml")

    -- "rocket jump" effect
    shot_effects.recoil_knockback = 280.0

    -- "Force pushing" enemy projectiles
    c.extra_entities = c.extra_entities .. MOD_PATH .. "weapons/air_blaster/projectile/wind_blast.xml,"
    -- draw_actions( 1, true )
  end,
})

table.insert( actions,
{
  id                = "WATER_CONTAINER",
  name              = "Water Container",
  description       = "Container for your water ammunition",
  sprite            = MOD_PATH .. "weapons/water_pistol/projectile/magazine.png",
  type              = ACTION_TYPE_PROJECTILE,
  spawn_level       = "0,4,5,6",
  spawn_probability = "1,1,1,1",
  price             = 600,
  mana              = 0,
  max_uses          = 1000,
  custom_xml_file = "mods/koira/files/weapons/magazine.xml",
  action = function()
    add_mod_projectile("weapons/water_pistol/projectile/entity.xml")
    c.damage_critical_chance = 0
  end,
})
