-- default biome functions that get called if we can't find a a specific biome that works for us
-- The level of action ids that are spawned from the chests
CHEST_LEVEL = 1
dofile_once("data/scripts/director_helpers.lua")
dofile_once("data/scripts/director_helpers_design.lua")
dofile_once("data/scripts/biome_scripts.lua")

dofile_once("mods/koira/files/scripts/biome_utilities.lua")

RegisterSpawnFunction( 0xff0000ff, "spawn_nest" )
RegisterSpawnFunction( 0xffB40000, "spawn_fungi" )
RegisterSpawnFunction( 0xff969678, "load_structures" )
RegisterSpawnFunction( 0xff967878, "load_large_structures" )
RegisterSpawnFunction( 0xff967896, "load_i_structures" )
RegisterSpawnFunction( 0xff80FF5A, "spawn_vines" )
RegisterSpawnFunction( 0xffC35700, "load_oiltank" )
RegisterSpawnFunction( 0xff55AF4B, "load_altar" )
RegisterSpawnFunction( 0xff23B9C3, "spawn_altar_torch" )
RegisterSpawnFunction( 0xff55AF8C, "spawn_skulls" )
RegisterSpawnFunction( 0xff55FF8C, "spawn_crate" )
RegisterSpawnFunction( 0xff4e175e, "load_oiltank_alt" )
RegisterSpawnFunction( 0xff50fafa, "spawn_trapwand" )

------------ small enemies -------------------------------

g_small_enemies =
{
	total_prob = 0,
	-- this is air, so nothing spawns at 0.6
	-- add skullflys after this step
	{
		prob   		= 0.5,
		min_count	= 1,
		max_count	= 2,
		entity 	= enemy_entity_path("zombie")
	},
	{
		prob   		= 0.1,
		min_count	= 3,
		max_count	= 5,
		entity 	= enemy_entity_path("bat")
	},
	{
		prob   		= 0.1,
		min_count	= 3,
		max_count	= 5,
		entity 	= enemy_entity_path("longleg")
	},
	{
		prob   		= 0.2,
		min_count	= 1,
		max_count	= 3,
		entity 	= enemy_entity_path("longleg")
	},
	{
		prob   		= 0.25,
		min_count	= 1,
		max_count	= 2,
		entity 	= enemy_entity_path("shotgunner")
	},
	{
		prob   		= 0.1,
		min_count	= 1,
		max_count	= 1,
		entity 	= enemy_entity_path("shotgunner")
	},
	-- Demo case for Arvi
	--[[
	{
		prob 		= 10,
		min_count	= 1,
		max_count 	= 1,
		entities = {
			{
				min_count	= 1,
				max_count 	= 5,
				entity = "data/entities/animals/shotgunner.xml",
			},
			{
				min_count = 10,
				max_count= 12,
				entity = "data/entities/animals/roboguard.xml",
			},
			"data/entities/items/chest_stash.xml",
		}
	},
	]]--
}

g_big_enemies =
{
	total_prob = 0,
	{
		prob   		= 0.2,
		min_count	= 5,
		max_count	= 10,
		entity 	= enemy_entity_path("longleg")
	},
	{
		prob   		= 0.2,
		min_count	= 5,
		max_count	= 10,
		entity 	= enemy_entity_path("longleg")
	},
	{
		prob   		= 0.1,
		min_count	= 1,
		max_count	= 1,
		entities 	= {
			"data/entities/animals/miner_weak.xml",
			enemy_entity_path("shotgunner"),
			enemy_entity_path("shotgunner")
		}
	},
	{
		prob   		= 0.12,
		min_count	= 1,
		max_count	= 1,
		entity 	= enemy_entity_path("shotgunner")
	},
	{
		prob   		= 0.1,
		min_count	= 2,
		max_count	= 4,
		entity 	= enemy_entity_path("cacodemon")
	},
	{
		prob   		= 0.49,
		min_count	= 1,
		max_count	= 1,
		entity 	= enemy_entity_path("cacodemon")
	},
	{
		prob   		= 0.3,
		min_count	= 1,
		max_count	= 2,
    entity 	= enemy_entity_path("nope")
	},
}

g_lamp =
{
  total_prob = 0,
  -- add skullflys after this step
  {
    prob       = 0.4,
    min_count  = 1,
    max_count  = 1,
    entity   = ""
  },
  {
    prob       = 0.7,
    min_count  = 1,
    max_count  = 1,
    entity     = "mods/koira/files/items/lanterns/small.xml"
  },
}

---------- UNIQUE ENCOUNTERS ---------------

g_unique_enemy =
{
  total_prob = 0,
  -- this is air, so nothing spawns at 0.6
  {
    prob       = 0.0,
    min_count  = 0,
    max_count  = 0,
    entity   = ""
  },
  -- add skullflys after this step
  {
    prob       = 0.5,
    min_count  = 1,
    max_count  = 3,
    entity   = enemy_entity_path("cacodemon")
  },
}

g_unique_enemy2 =
{
  total_prob = 0,
  -- this is air, so nothing spawns at 0.6
  {
    prob       = 0.3,
    min_count  = 3,
    max_count  = 5,
    entity   = enemy_entity_path("cacodemon")
  },
  {
    prob       = 1.5,
    min_count  = 0,
    max_count  = 0,
    entity   = ""
  },
  -- add skullflys after this step
  {
    prob       = 0.5,
    min_count  = 1,
    max_count  = 1,
    entity   = enemy_entity_path("shotgunner")
  },
  {
    prob       = 0.5,
    min_count  = 2,
    max_count  = 2,
    entity   = "data/entities/animals/miner_weak.xml"
  },
  {
    prob       = 0.5,
    min_count  = 1,
    max_count  = 1,
    entity   = enemy_entity_path("cacodemon")
  },
}

g_unique_enemy3 =
{
  total_prob = 0,
  -- this is air, so nothing spawns at 0.6
  {
    prob       = 0.0,
    min_count  = 0,
    max_count  = 0,
    entity   = ""
  },
  {
    prob       = 0.1,
    min_count  = 10,
    max_count  = 10,
    entity   = enemy_entity_path("cacodemon")
  },
}

g_fungi =
{
  total_prob = 0,
  -- this is air, so nothing spawns at 0.6
  {
    prob       = 0.5,
    min_count  = 0,
    max_count  = 0,
    entity   = ""
  },
  -- add skullflys after this step
  {
    prob       = 0.5,
    min_count  = 1,
    max_count  = 1,
    entity   = "data/entities/animals/fungus.xml"
  },
  {
    prob       = 0.05,
    min_count  = 1,
    max_count  = 1,
    entity   = "data/entities/animals/fungus_big.xml"
  },
}

------------ items -------------------------------

g_items =
{
  total_prob = 0,
  -- this is air, so nothing spawns at 0.6
  {
    prob       = 0,
    min_count  = 0,
    max_count  = 0,
    entity   = ""
  },
}

--- barrels ---

g_props =
{
  total_prob = 0,
  {
    prob       = 0.2,
    min_count  = 0,
    max_count  = 0,
    offset_y   = 0,
    entity   = ""
  },
  {
    prob       = 0.5,
    min_count  = 1,
    max_count  = 1,
    offset_y   = 0,
    entity   = "data/entities/props/physics_box_explosive.xml"
  },
  {
    prob       = 0.25,
    min_count  = 1,
    max_count  = 1,
    offset_y   = -5,
    entity   = "data/entities/props/physics_minecart.xml"
  },
  {
    prob       = 0.25,
    min_count  = 1,
    max_count  = 1,
    offset_y   = -5,
    entity   = "data/entities/props/physics_cart.xml"
  },
  {
    prob       = 0.1,
    min_count  = 1,
    max_count  = 1,
    offset_y   = 0,
    entity   = "data/entities/props/physics_barrel_radioactive.xml"
  },
  {
    prob       = 0.3,
    min_count  = 1,
    max_count  = 1,
    offset_y   = 0,
    entity   = "data/entities/props/physics_barrel_oil.xml"
  },
}

g_props2 =
{
  total_prob = 0,
  {
    prob       = 0.5,
    min_count  = 0,
    max_count  = 0,
    offset_y   = 0,
    entity   = ""
  },
  {
    prob       = 0.2,
    min_count  = 1,
    max_count  = 1,
    offset_y   = -5,
    entity   = "data/entities/props/physics_minecart.xml"
  },
  {
    prob       = 0.5,
    min_count  = 1,
    max_count  = 1,
    offset_y   = -5,
    entity   = "data/entities/props/physics_brewing_stand.xml"
  },
}

g_props3 =
{
  total_prob = 0,
  {
    prob       = 0.1,
    min_count  = 0,
    max_count  = 0,
    offset_y   = 0,
    entity   = ""
  },
  {
    prob       = 0.3,
    min_count  = 1,
    max_count  = 1,
    offset_y   = -5,
    entity   = "data/entities/items/pickup/potion.xml"
  },
  --[[
  {
    prob       = 0.3,
    min_count  = 1,
    max_count  = 1,
    offset_y   = -5,
    entity   = "data/entities/props/physics_bottle_green.xml"
  },
  {
    prob       = 0.3,
    min_count  = 1,
    max_count  = 1,
    offset_y   = -5,
    entity   = "data/entities/props/physics_bottle_red.xml"
  },
  {
    prob       = 0.3,
    min_count  = 1,
    max_count  = 1,
    offset_y   = -5,
    entity   = "data/entities/props/physics_bottle_blue.xml"
  },
  {
    prob       = 0.2,
    min_count  = 1,
    max_count  = 1,
    offset_y   = -5,
    entity   = "data/entities/props/physics_bottle_yellow.xml"
  },
  ]]--
}

--- pixelscenes ---

g_pixel_scene_01 =
{
  total_prob = 0,
  {
    prob         = 0.5,
    material_file   = "data/biome_impl/coalmine/coalpit01.png",
    visual_file    = "data/biome_impl/coalmine/coalpit01_visual.png",
    background_file  = "",
    is_unique    = 0,
  },
  {
    prob         = 0.5,
    material_file   = "data/biome_impl/coalmine/coalpit02.png",
    visual_file    = "data/biome_impl/coalmine/coalpit02_visual.png",
    background_file  = "",
    is_unique    = 0,
  },
  {
    prob         = 0.5,
    material_file   = "data/biome_impl/coalmine/carthill.png",
    visual_file    = "data/biome_impl/coalmine/carthill_visual.png",
    background_file  = "",
    is_unique    = 0,
  },
  {
    prob         = 0.5,
    material_file   = "data/biome_impl/coalmine/coalpit03.png",
    visual_file    = "data/biome_impl/coalmine/coalpit03_visual.png",
    background_file  = "",
    is_unique    = 0,
  },
  {
    prob         = 0.5,
    material_file   = "data/biome_impl/coalmine/coalpit04.png",
    visual_file    = "data/biome_impl/coalmine/coalpit04_visual.png",
    background_file  = "",
    is_unique    = 0,
  },
  {
    prob         = 0.5,
    material_file   = "data/biome_impl/coalmine/coalpit05.png",
    visual_file    = "data/biome_impl/coalmine/coalpit05_visual.png",
    background_file  = "",
    is_unique    = 0,
  },
}

g_pixel_scene_02 =
{
  total_prob = 0,
  {
    prob         = 0.5,
    material_file   = "data/biome_impl/coalmine/shrine01.png",
    visual_file    = "data/biome_impl/coalmine/shrine01_visual.png",
    background_file  = "",
    is_unique    = 0
  },
  {
    prob         = 0.5,
    material_file   = "data/biome_impl/coalmine/shrine02.png",
    visual_file    = "data/biome_impl/coalmine/shrine02_visual.png",
    background_file  = "",
    is_unique    = 0
  },
  {
    prob         = 0.5,
    material_file   = "data/biome_impl/coalmine/slimepit.png",
    visual_file    = "data/biome_impl/coalmine/slimepit_visual.png",
    background_file  = "",
    is_unique    = 0
  },
  {
    prob         = 0.5,
    material_file   = "data/biome_impl/coalmine/laboratory.png",
    visual_file    = "data/biome_impl/coalmine/laboratory_visual.png",
    background_file  = "",
    is_unique    = 0
  },
  {
    prob         = 0.5,
    material_file   = "data/biome_impl/coalmine/swarm.png",
    visual_file    = "data/biome_impl/coalmine/swarm_visual.png",
    background_file  = "",
    is_unique    = 0
  },
  {
    prob         = 0.5,
    material_file   = "data/biome_impl/coalmine/symbolroom.png",
    visual_file    = "",
    background_file  = "",
    is_unique    = 0
  },
  {
    prob         = 1.2,
    material_file   = "data/biome_impl/coalmine/physics_01.png",
    visual_file    = "data/biome_impl/coalmine/physics_01_visual.png",
    background_file  = "",
    is_unique    = 0
  },
  {
    prob         = 1.2,
    material_file   = "data/biome_impl/coalmine/physics_02.png",
    visual_file    = "data/biome_impl/coalmine/physics_02_visual.png",
    background_file  = "",
    is_unique    = 0
  },
  {
    prob         = 1.2,
    material_file   = "data/biome_impl/coalmine/physics_03.png",
    visual_file    = "",
    background_file  = "",
    is_unique    = 0
  },
  {
    prob         = 0.75,
    material_file   = "data/biome_impl/coalmine/shop.png",
    visual_file    = "data/biome_impl/coalmine/shop_visual.png",
    background_file  = "",
    is_unique    = 0
  },
  {
    prob         = 0.1,
    material_file   = "data/biome_impl/coalmine/radioactivecave.png",
    visual_file    = "",
    background_file  = "",
    is_unique    = 0
  },
}

g_oiltank =
{
  total_prob = 0,
  {
    prob         = 1.0,
    material_file   = "data/biome_impl/coalmine/oiltank_1.png",
    visual_file    = "data/biome_impl/coalmine/oiltank_1_visual.png",
    background_file  = "",
    is_unique    = 0,
    color_material = { ["fff0bbee"] = { "water", "oil", "water", "oil", "alcohol", "sand", "coal", "radioactive_liquid" } }
  },
  -- secret / magic materials tanker
  {
    prob         = 0.0004,
    material_file   = "data/biome_impl/coalmine/oiltank_1.png",
    visual_file    = "data/biome_impl/coalmine/oiltank_1_visual.png",
    background_file  = "",
    is_unique    = 0,
    color_material = { ["fff0bbee"] = { "magic_liquid_teleportation", "magic_liquid_polymorph", "magic_liquid_random_polymorph", "magic_liquid_berserk", "magic_liquid_charm", "magic_liquid_invisibility", "magic_liquid_hp_regeneration", "salt", "blood", "gold", "honey" } }
  },
  -- more common, but weirder
  {
    prob         = 0.01,
    material_file   = "data/biome_impl/coalmine/oiltank_2.png",
    visual_file    = "data/biome_impl/coalmine/oiltank_2_visual.png",
    background_file  = "",
    is_unique    = 0,
    color_material = { ["fff0bbee"] = { "blood_fungi", "blood_cold", "lava", "poison", "slime", "gunpowder_explosive", "soil", "salt", "blood", "cement" } }
  },

  {
    prob         = 1.0,
    material_file   = "data/biome_impl/coalmine/oiltank_2.png",
    visual_file    = "data/biome_impl/coalmine/oiltank_2_visual.png",
    background_file  = "",
    is_unique    = 0,
    color_material = { ["fff0bbee"] = { "water", "oil", "water", "oil", "alcohol", "oil", "coal", "radioactive_liquid" } }
  },
  {
    prob         = 1.0,
    material_file   = "data/biome_impl/coalmine/oiltank_3.png",
    visual_file    = "data/biome_impl/coalmine/oiltank_3_visual.png",
    background_file  = "",
    is_unique    = 0,
    color_material = { ["fff0bbee"] = { "water", "oil", "water", "oil", "alcohol", "water", "coal", "radioactive_liquid", "magic_liquid_teleportation" } }
  },
  {
    prob         = 1.0,
    material_file   = "data/biome_impl/coalmine/oiltank_4.png",
    visual_file    = "data/biome_impl/coalmine/oiltank_4_visual.png",
    background_file  = "",
    is_unique    = 0,
    color_material = { ["fff0bbee"] = { "water", "oil", "water", "oil", "alcohol", "sand", "coal", "radioactive_liquid", "magic_liquid_polymorph" } }
  },
  {
    prob         = 1.0,
    material_file   = "data/biome_impl/coalmine/oiltank_5.png",
    visual_file    = "",
    background_file  = "",
    is_unique    = 0,
    color_material = { ["fff0bbee"] = { "water", "oil", "water", "oil", "alcohol", "radioactive_liquid", "coal", "radioactive_liquid" } }
  },
}

g_oiltank_alt =
{
  total_prob = 0,
  {
    prob         = 1.0,
    material_file   = "data/biome_impl/coalmine/oiltank_alt.png",
    visual_file    = "data/biome_impl/coalmine/oiltank_alt_visual.png",
    background_file  = "",
    color_material = { ["fff0bbee"] = { "water", "oil", "water", "oil", "alcohol", "sand", "radioactive_liquid", "radioactive_liquid", "magic_liquid_berserk" } }
  },
}

g_i_structures =
{
  total_prob = 0,
  {
    prob       = 0.1,
    min_count  = 0,
    max_count  = 0,
    offset_y   = 0,
    entity   = ""
  },
  {
    prob       = 0.3,
    min_count  = 1,
    max_count  = 1,
    offset_y   = -5,
    entity   = "data/entities/props/coalmine_i_structure_01.xml"
  },
  {
    prob       = 0.3,
    min_count  = 1,
    max_count  = 1,
    offset_y   = -5,
    entity   = "data/entities/props/coalmine_i_structure_02.xml"
  },
}

g_structures =
{
  total_prob = 0,
  {
    prob       = 0.1,
    min_count  = 0,
    max_count  = 0,
    offset_y   = 0,
    entity   = ""
  },
  {
    prob       = 0.3,
    min_count  = 1,
    max_count  = 1,
    offset_y   = -5,
    entity   = "data/entities/props/coalmine_structure_01.xml"
  },
  {
    prob       = 0.3,
    min_count  = 1,
    max_count  = 1,
    offset_y   = -5,
    entity   = "data/entities/props/coalmine_structure_01.xml"
  },
}

g_large_structures =
{
  total_prob = 0,
  {
    prob       = 0.1,
    min_count  = 0,
    max_count  = 0,
    offset_y   = 0,
    entity   = ""
  },
  {
    prob       = 0.3,
    min_count  = 1,
    max_count  = 1,
    offset_y   = -5,
    entity   = "data/entities/props/coalmine_large_structure_01.xml"
  },
  {
    prob       = 0.3,
    min_count  = 1,
    max_count  = 1,
    offset_y   = -5,
    entity   = "data/entities/props/coalmine_large_structure_02.xml"
  },
}

g_ghostlamp =
{
  total_prob = 0,
  -- add skullflys after this step
  {
    prob       = 1.0,
    min_count  = 1,
    max_count  = 1,
    offset_y  = 10,
    entity   = "data/entities/props/physics_chain_torch_ghostly.xml"
  },
}

g_candles =
{
  total_prob = 0,
  {
    prob       = 0.33,
    min_count  = 1,
    max_count  = 1,
    entity   = "data/entities/props/physics_candle_1.xml"
  },
  {
    prob       = 0.33,
    min_count  = 1,
    max_count  = 1,
    entity   = "data/entities/props/physics_candle_2.xml"
  },
  {
    prob       = 0.33,
    min_count  = 1,
    max_count  = 1,
    entity   = "data/entities/props/physics_candle_3.xml"
  },
}

g_nest =
{
  total_prob = 0,
  -- add skullflys after this step
  {
    prob       = 0.5,
    min_count  = 1,
    max_count  = 1,
    entity   = "data/entities/buildings/flynest.xml"
  },
  {
    prob       = 0.5,
    min_count  = 1,
    max_count  = 1,
    entity   = ""
  },
}

g_vines =
{
  total_prob = 0,
  {
    prob       = 0.4,
    min_count  = 1,
    max_count  = 1,
    entity   = "data/entities/verlet_chains/vines/verlet_vine.xml"
  },
  {
    prob       = 0.3,
    min_count  = 1,
    max_count  = 1,
    entity   = "data/entities/verlet_chains/vines/verlet_vine_long.xml"
  },
  {
    prob       = 1.5,
    min_count  = 1,
    max_count  = 1,
    entity   = ""
  },
  {
    prob       = 0.5,
    min_count  = 1,
    max_count  = 1,
    entity   = "data/entities/verlet_chains/vines/verlet_vine_short.xml"
  },
  {
    prob       = 0.5,
    min_count  = 1,
    max_count  = 1,
    entity   = "data/entities/verlet_chains/vines/verlet_vine_shorter.xml"
  },
}

--------------

function spawn_items( pos_x, pos_y )
end

-- actual functions that get called from the wang generator


function spawn_small_enemies(x, y)
  spawn(g_small_enemies,x,y)
  --local r = ProceduralRandom( x, y )
  --local spawn_percent = BiomeMapGetVerticalPositionInsideBiome( x, y )
  --spawn_with_limited_random(g_small_enemies,x,y,0,0,{"longleg","fungus"})
  ----spawn_hp(g_small_enemies,x,y,0,0,0.4,"coalmines")
end

function spawn_big_enemies(x, y)
  spawn(g_big_enemies,x,y)
  --local r = ProceduralRandom( x, y )
  --local spawn_percent = BiomeMapGetVerticalPositionInsideBiome( x, y )
  --spawn_percent = ( 1.75 * spawn_percent ) - 0.1
  --if( r > spawn_percent ) then return end
  --spawn_with_limited_random(g_big_enemies,x,y,0,0,{"longleg","fungus"})
  --spawn_hp(g_big_enemies,x,y,0,0,0.4,"coalmines")
end

function spawn_lamp(x, y)
  spawn(g_lamp,x,y+2,0,0)
end

function spawn_props(x, y)
  spawn(g_props,x,y-3,0,0)
end

function spawn_props2(x, y)
  spawn(g_props2,x,y-3,0,0)
end

function spawn_props3(x, y)
  --spawn(g_props3,x,y,0,0)
end

function spawn_unique_enemy(x, y)
  spawn(g_unique_enemy,x,y)
end

function spawn_unique_enemy2(x, y)
  spawn(g_unique_enemy2,x,y)
end

function spawn_unique_enemy3(x, y)
  spawn(g_unique_enemy3,x,y)
end

function spawn_fungi(x, y)
  spawn(g_fungi,x,y)
end

function load_oiltank( x, y )
  load_random_pixel_scene( g_oiltank, x, y )
end

function load_oiltank_alt( x, y )
  load_random_pixel_scene( g_oiltank_alt, x, y )
end

function load_altar( x, y )
  --LoadPixelScene( "data/biome_impl/altar.png", "data/biome_impl/altar_visual.png", x-92, y-96, "", true )
  --EntityLoad( "data/entities/buildings/altar.xml", x, y-32 )
end

function load_structures( x, y )
  spawn( g_structures, x, y-30, 0, 0 )
end

function load_large_structures( x, y )
  spawn( g_large_structures, x, y-30, 0, 0 )
end

function load_i_structures( x, y )
  spawn( g_i_structures, x, y-30, 0, 0 )
end

function spawn_stash(x,y)
end

function spawn_nest(x, y)
  spawn(g_nest,x+4,y)
end

function spawn_vines(x, y)
  spawn(g_vines,x+5,y+5)
end

function spawn_altar_torch(x, y)
  EntityLoad( "data/entities/props/altar_torch.xml", x-7, y-38 )
end

function spawn_crate(x, y)
  spawn_random_weapons_crate(x, y)
end

function spawn_skulls(x, y) end

function spawn_trapwand(x, y)
  spawn_crate(x, y)
end
