-- default biome functions that get called if we can't find a a specific biome that works for us
CHEST_LEVEL = 0
dofile_once("data/scripts/director_helpers.lua")
dofile_once("data/scripts/biome_scripts.lua")

dofile_once("mods/koira/files/scripts/biome_utilities.lua")


--
-- GLOBAL SPAWNING FUNCTIONS
--
-- All colors are registered in `data/scripts/wang_scripts.csv`
--


function spawn_vine(x, y) EntityLoad("data/entities/verlet_chains/vines/verlet_vine.xml", x, y) end
function spawn_vine_long(x, y) EntityLoad("data/entities/verlet_chains/vines/verlet_vine_long.xml", x, y) end
function spawn_vine_short(x, y) EntityLoad("data/entities/verlet_chains/vines/verlet_vine_short.xml", x, y) end
function spawn_vine_shorter(x, y) EntityLoad("data/entities/verlet_chains/vines/verlet_vine_shorter.xml", x, y) end

RegisterSpawnFunction( 0xff571d91, "spawn_water_pistol" )
RegisterSpawnFunction( 0xff2a9db3, "spawn_corpse" )

RegisterSpawnFunction( 0xffa616aa, "spawn_machinegun" )
RegisterSpawnFunction( 0xff0d8691, "spawn_miner_chef" )

RegisterSpawnFunction( 0xff1712c3, "spawn_dog_ending" )

RegisterSpawnFunction( 0xff17a276, "spawn_save_point_mountain" )

RegisterSpawnFunction( 0xff9512c3, "spawn_monkey_mask" )
RegisterSpawnFunction( 0xffd5aa08, "spawn_monkey" )
RegisterSpawnFunction( 0xffb5dae6, "spawn_frog_big" )
-- RegisterSpawnFunction( 0xff8b8b99, "spawn_fly_hive" )
RegisterSpawnFunction( 0xff7c3ebb, "spawn_scavenger_mine" )
RegisterSpawnFunction( 0xffd50606, "spawn_fly" )
RegisterSpawnFunction( 0xffdd0cd2, "spawn_bloom" )

RegisterSpawnFunction( 0xff0a6f17, "spawn_save_point_nightmare2" )
RegisterSpawnFunction( 0xff651faa, "spawn_save_point_jungle" )
RegisterSpawnFunction( 0xff2f3377, "spawn_save_point_factory_out" )

RegisterSpawnFunction( 0xff18cc13, "spawn_metal_door_switch" )
RegisterSpawnFunction( 0xff060533, "spawn_scavenger_smg" )
RegisterSpawnFunction( 0xff1498d5, "spawn_marauder_super" )
RegisterSpawnFunction( 0xffa35fd5, "spawn_tube_lamp" )

RegisterSpawnFunction( 0xffacc2cc, "spawn_clone_giant" )
RegisterSpawnFunction( 0xffd51111, "spawn_clone" )

RegisterSpawnFunction( 0xff3c19d5, "spawn_cyborg" )
RegisterSpawnFunction( 0xff13bb0f, "spawn_sniper_stealth" )
RegisterSpawnFunction( 0xff2b8830, "spawn_lua_bridge" )
RegisterSpawnFunction( 0xff5a3f5e, "spawn_giant_shield_generator" )
RegisterSpawnFunction( 0xffb3aa0e, "spawn_marauder" )

RegisterSpawnFunction( 0xffdd0f0f, "spawn_robot_mask" )
RegisterSpawnFunction( 0xff112e33, "spawn_cover_switch" )

RegisterSpawnFunction( 0xff2e0533, "spawn_fan_horizontal_on_left" )
RegisterSpawnFunction( 0xff990c70, "spawn_fan_horizontal_on" )
RegisterSpawnFunction( 0xff1b0677, "spawn_fan_horizontal" )
RegisterSpawnFunction( 0xff0c5866, "spawn_fan_switch2" )

RegisterSpawnFunction( 0xff280baa, "spawn_fan" )
RegisterSpawnFunction( 0xff12c5e6, "spawn_fan_switch" )
RegisterSpawnFunction( 0xffe61298, "spawn_commander" )
RegisterSpawnFunction( 0xff0d4980, "spawn_assassin" )
RegisterSpawnFunction( 0xff0e3f99, "spawn_doctor_enemy" )
RegisterSpawnFunction( 0xff9db313, "spawn_fish" )
RegisterSpawnFunction( 0xff8518b3, "spawn_turret" )
RegisterSpawnFunction( 0xff1477bb, "spawn_carousel" )
RegisterSpawnFunction( 0xff12bb92, "spawn_windmill" )
RegisterSpawnFunction( 0xff1eaa44, "spawn_dog_fake" )
RegisterSpawnFunction( 0xffc30da1, "spawn_bone_fake" )
RegisterSpawnFunction( 0xffbb7519, "spawn_turret_roof" )
RegisterSpawnFunction( 0xff002e66, "spawn_shield_generator" )
RegisterSpawnFunction( 0xff10aa2d, "spawn_save_point_factory" )
RegisterSpawnFunction( 0xff720e88, "spawn_chicken_mask" )
RegisterSpawnFunction( 0xff10cc46, "spawn_bridge" )
RegisterSpawnFunction( 0xffee890d, "spawn_save_point_farm_end" )

function spawn_corpse(x, y)
	function create_ragdoll(path)
	
		local ragdoll_id = EntityCreateNew()
		EntitySetTransform(ragdoll_id, x, y)
		
		EntityAddComponent(ragdoll_id, "DamageModelComponent", {
            hp="1",
            ragdoll_material="bone",
			ragdoll_filenames_file = path ,
			blood_material="blood",
			blood_spray_material="blood",
			ragdoll_offset_y = 0,
			ragdoll_offset_x = 0
		} )
		
		local ragdoll_damage_model_component = EntityGetFirstComponentIncludingDisabled(ragdoll_id, "DamageModelComponent")
		
		ComponentSetValue2(ragdoll_damage_model_component, "hp", 0)
		ComponentSetValue2(ragdoll_damage_model_component, "air_needed", true)
		ComponentSetValue2(ragdoll_damage_model_component, "air_in_lungs", 0)
	
	end
	
	-- SetRandomSeed( GameGetFrameNum(), x + y )
	-- local paths = { "data/ragdolls/skeleton/filenames.txt", "data/ragdolls/failed_alchemist_b/filenames.txt", "data/ragdolls/enlightened_alchemist/filenames.txt" }
	-- local random_index = Random(1, #paths)
	-- local path = paths[random_index]
	create_ragdoll("data/ragdolls/skeleton/filenames.txt")
end

function spawn_water_pistol(x, y)
  EntityLoad(MOD_PATH .. "weapons/water_pistol/gun.xml", x, y)
end

function spawn_machinegun(x, y)
  EntityLoad(MOD_PATH .. "weapons/machinegun/gun.xml", x, y)
end

function spawn_miner_chef(x, y)
  local entity1 = EntityLoad("data/entities/animals/miner_chef.xml", x, y)
  local entity2 = EntityLoad("data/entities/animals/miner_santa.xml", x, y)
  local pickupper1 = EntityGetFirstComponent( entity1, "ItemPickUpperComponent")
  local pickupper2 = EntityGetFirstComponent( entity2, "ItemPickUpperComponent")
  EntitySetComponentIsEnabled( entity1, pickupper1, false )
  EntitySetComponentIsEnabled( entity2, pickupper2, false )
end

function spawn_save_point_nightmare2(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/factory_save/nightmare_save.xml", x, y)
end

function spawn_save_point_farm_end(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/factory_save/farm_end_save.xml", x, y)
end

function spawn_save_point_mountain(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/factory_save/mountain_save.xml", x, y)
end

function spawn_monkey_mask(x, y)
  EntityLoad(MOD_PATH .. "items/mask/monkey.xml", x, y)
end

function spawn_monkey(x, y)
  spawn_enemy("monkey", x, y)
end

function spawn_frog_big(x, y)
  spawn_enemy("frog_big", x, y)
end

function spawn_fly_hive(x, y)
  spawn_enemy("fly_hive", x, y)
end

function spawn_scavenger_mine(x, y)
  spawn_enemy("scavenger_mine", x, y)
end

function spawn_bloom(x, y)
  spawn_enemy("bloom", x, y)
end

function spawn_fly(x, y)
  spawn_enemy("fly", x, y)
end

function spawn_metal_door_switch(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/door_metal/door_metal_switch.xml", x, y)
end

function spawn_scavenger_smg(x, y)
  spawn_enemy("scavenger_smg", x, y)
end

function spawn_save_point_jungle(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/factory_save/jungle_save.xml", x, y)
end

function spawn_save_point_factory_out(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/factory_save/factory_save_out.xml", x, y)
end

function spawn_fan_horizontal_on_left(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/fan/fan4.xml", x, y)
end

function spawn_fan_horizontal_on(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/fan/fan3.xml", x, y)
end

function spawn_marauder_super(x, y)
  spawn_enemy("marauder_super", x, y)
end

function spawn_tube_lamp(x, y)
  EntityLoad("data/entities/props/physics_tubelamp.xml", x, y)
end

function spawn_clone_giant(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/clone/clone_giant.xml", x, y)
end

function spawn_clone(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/clone/clone.xml", x, y)
end

function spawn_dog_ending(x, y)
  EntityLoad("mods/koira/files/enemies/the_dog/the_dog_ending.xml", x, y)
end

function spawn_cyborg(x, y)
  spawn_enemy("cyborg", x, y)
end

function spawn_sniper_stealth(x, y) spawn_enemy("sniper_stealth", x, y) end

function spawn_lua_bridge(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/lua_bridge/lua_wall.xml", x, y)
end

function spawn_giant_shield_generator(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/forcefield_generator/forcefield_generator_giant.xml", x, y - 7)
end

function spawn_robot_mask(x, y)
  EntityLoad(MOD_PATH .. "items/mask/robot.xml", x, y)
end

function spawn_cover_switch(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/cover/switch.xml", x, y)
end

function spawn_marauder(x, y)
  spawn_enemy("marauder", x, y)
end

function spawn_fan_switch2(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/fan/switch2.xml", x, y)
end

function spawn_fan_horizontal(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/fan/fan2.xml", x, y)
end

function spawn_fan_switch(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/fan/switch.xml", x, y)
end

function spawn_fan(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/fan/fan.xml", x, y)
end

function spawn_commander(x, y)
  spawn_enemy("commander", x, y)
end

function spawn_assassin(x, y)
  spawn_enemy("assassin", x, y)
end

function spawn_bridge(x, y)
  EntityLoad("data/entities/props/physics_spawners/physics_suspension_bridge_spawner.xml", x - 5, y)
end

function spawn_chicken_mask(x, y)
  EntityLoad(MOD_PATH .. "items/mask/chicken.xml", x, y)
end

function spawn_save_point_factory(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/factory_save/factory_save.xml", x, y)
end

function spawn_shield_generator(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/forcefield_generator/forcefield_generator.xml", x, y - 7)
end

function spawn_turret_roof(x, y)
  spawn_enemy("tank_roof", x, y + 16)
end

function spawn_dog_fake(x, y)
  local dog = EntityLoad("mods/koira/files/enemies/the_dog/the_dog.xml", x, y)
  
	EntityAddComponent(dog, "LuaComponent", {
		script_source_file="mods/koira/files/scripts/kill_when_woke.lua",
		execute_every_n_frame=5,
		execute_on_added=1
	})
end

function spawn_bone_fake(x, y)
  local bone = EntityLoad("mods/koira/files/items/the_bone/the_bone.xml", x, y)
	EntityAddComponent(bone, "LuaComponent", {
		script_source_file="mods/koira/files/scripts/kill_when_woke.lua",
		execute_every_n_frame=5,
		execute_on_added=1
	})
end

function spawn_doctor_enemy(x, y) spawn_enemy("doctor", x, y) end

function spawn_fish(x, y)
  EntityLoad("data/entities/animals/fish_large.xml", x, y)
  EntityLoad("data/entities/animals/fish_large.xml", x, y)
  EntityLoad("data/entities/animals/fish_large.xml", x, y)
end

function spawn_windmill(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/windmill/windmill.xml", x - 39, y - 111)
end

function spawn_carousel(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/carousel/carousel.xml", x, y)
  spawn_enemy("shotgunner_stealth", x - 23, y + 60)
  spawn_enemy("shotgunner_stealth", x + 23, y + 60)
end

function spawn_turret(x, y)
  spawn_enemy("tank", x, y)
end

function spawn_small_enemies(x, y)
  spawn_enemy("shotgunner", x, y)
end


-- BIOME ITEMS & THINGS
function spawn_lamp(x, y)
  EntityLoad("mods/koira/files/items/lanterns/small.xml", x+1, y+3)
end

function spawn_title(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/title/logo.xml", x, y)
end
function spawn_title_trigger(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/title/trigger.xml", x, y)
end

function spawn_bed(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/bed/bed.xml", x, y)
end

function spawn_hatch(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/hatch/hatch.xml", x, y-2)
end

function spawn_door(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/door/door.xml", x, y)
end

function spawn_door_metal(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/door_metal/door_metal.xml", x, y)
end

function spawn_door_probably_locked(x, y)
  SetRandomSeed(GameGetFrameNum(), GameGetFrameNum())
  local roll = Random(1, 100)

  if roll < 85 then
    EntityLoad(MOD_PATH .. "biomes/objects/door/door_locked.xml", x, y)
  else
    EntityLoad(MOD_PATH .. "biomes/objects/door/door.xml", x, y)
  end
end

function spawn_dog(x, y)
  EntityLoad("mods/koira/files/enemies/the_dog/the_dog.xml", x, y)
end
--00f00f is the dog spawner colour

function spawn_crate(x, y)
  spawn_random_weapons_crate(x, y)
end

function spawn_grenade(x, y)
  EntityLoad("mods/koira/files/items/grenade/grenade.xml", x, y)
end

function spawn_bball(x, y)
  -- Load the fake one, because real on doesn't like to be spawned on the
  -- ground alone; throws a tantrum and spins through the terrain geometry.
  EntityLoad("mods/koira/files/items/ball/fake_ball.xml", x, y)
end

function spawn_bone(x, y)
  EntityLoad("mods/koira/files/items/the_bone/the_bone.xml", x, y)
end
--ffb0be spawner colour

function spawn_blood_altar(x, y)
  EntityLoad("mods/koira/files/biomes/objects/blood_altar/blood_altar.xml", x, y)
end

function spawn_shock_trap(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/shock_trap/electricity.xml", x, y)
end
function spawn_shock_trap_switch(x, y)
  EntityLoad(MOD_PATH .. "biomes/objects/shock_trap/switch.xml", x, y)
end

-- GUNS
function spawn_arsenal(x, y) spawn_all_guns(x, y) end
function spawn_pistol(x, y) spawn_gun("pistol", x, y) end
function spawn_revolver(x, y) spawn_gun("revolver", x, y) end
function spawn_smg(x, y) spawn_gun("smg", x, y) end
function spawn_shotgun(x, y) spawn_gun("shotgun", x, y) end
function spawn_assault_rifle(x, y) spawn_gun("assault_rifle", x, y) end
function spawn_rifle(x, y) spawn_gun("rifle", x, y) end
function spawn_rocket_launcher(x, y) spawn_gun("rocket_launcher", x, y) end
function spawn_grenade_launcher(x, y) spawn_gun("grenade_launcher", x, y) end
function spawn_flammenwerfer(x, y) spawn_gun("flammenwerfer", x, y) end
function spawn_lightning_gun(x, y) spawn_gun("lightning_gun", x, y) end
function spawn_railgun(x, y) spawn_gun("railgun", x, y) end
function spawn_plasmagun(x, y) spawn_gun("plasmagun", x, y) end
function spawn_knife(x, y) spawn_gun("knife", x, y) end
function spawn_chainsaw(x, y) spawn_gun("chainsaw", x, y) end
function spawn_stakegun(x, y) spawn_gun("stakegun", x, y) end

-- ENEMIES
function spawn_lumberjack(x, y) spawn_enemy("lumberjack", x, y) end
function spawn_doctor(x, y) spawn_enemy("shepherd", x, y) end
function spawn_shotgunner(x, y) spawn_enemy("shotgunner", x, y) end
function spawn_shepherd(x, y) spawn_enemy("shepherd", x, y) end
function spawn_nope(x, y) spawn_enemy("nope", x, y) end
function spawn_nope(x, y) EntityLoad("data/entities/animals/lukki/lukki_longleg.xml", x, y) end

function spawn_neukkuhiisi(x, y) spawn_enemy("shotgunner", x, y) end

function spawn_snipuneukku(x, y) spawn_enemy("sniper", x, y) end

function spawn_noita_trigger(x, y)
  EntityLoad("mods/koira/files/enemies/noita/trigger.xml", x, y)
end
function spawn_noita_locator(x, y)
  EntityLoad("mods/koira/files/enemies/noita/spawn_location.xml", x, y)
end

-- HARMLESS
function spawn_sheep(x, y) spawn_enemy("sheep", x, y) end
function spawn_sheep_horny(x, y) spawn_enemy("sheep", x, y) end


--[[
  load_verlet_rope_with_two_joints("data/entities/verlet_chains/vines/verlet_vine_pixelscene.xml", x+325, y+342, x+374, y+371)
  load_verlet_rope_with_two_joints("data/entities/verlet_chains/vines/verlet_vine_long_pixelscene.xml", x+216, y+278, x+272, y+314)
  load_verlet_rope_with_one_joint("data/entities/verlet_chains/vines/verlet_vine_short_pixelscene.xml", x+356, y+354)
  load_verlet_rope_with_one_joint("data/entities/verlet_chains/vines/verlet_vine_shorter_pixelscene.xml", x+184, y+276)
]]--
