-- default biome functions that get called if we can't find a a specific biome that works for us
CHEST_LEVEL = 3
dofile_once("data/scripts/director_helpers.lua")
dofile_once("data/scripts/biome_scripts.lua")

RegisterSpawnFunction( 0xffffeedd, "init" )
RegisterSpawnFunction( 0xff172cb8, "spawn_corpse" )
RegisterSpawnFunction( 0xff0baaaa, "spawn_air_blaster" )
RegisterSpawnFunction( 0xffffb539, "random_layout" )

g_small_enemies =
{
	total_prob = 0,
	-- this is air, so nothing spawns at 0.6
	{
		prob   		= 0.1,
		min_count	= 0,
		max_count	= 0,    
		entity 	= ""
	},
	-- add skullflys after this step
	{
		prob   		= 0.1,
		min_count	= 1,
		max_count	= 2,    
		entity 	= "data/entities/animals/slimeshooter.xml"
	},
	{
		prob   		= 0.1,
		min_count	= 1,
		max_count	= 2,    
		entity 	= "data/entities/animals/acidshooter.xml"
	},
	{
		prob   		= 0.02,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/animals/giantshooter.xml"
	},
	{
		prob   		= 0.05,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/animals/lasershooter.xml"
	},
}

function spawn_small_enemies(x, y)
	spawn(g_small_enemies,x,y)
end

function spawn_big_enemies( x, y ) end
function spawn_props2( x, y ) end
function spawn_props3( x, y ) end
function spawn_lamp( x, y ) end
function load_pixel_scene( x, y ) end
function load_pixel_scene2( x, y ) end
function spawn_unique_enemy( x, y ) end
function spawn_unique_enemy2( x, y ) end
function spawn_unique_enemy3( x, y ) end
function spawn_ghostlamp( x, y ) end
function spawn_candles( x, y ) end
function spawn_potions( x, y ) end

function init( x, y )
	-- local r = math.floor(ProceduralRandom(x, y, 1, 6))
	LoadPixelScene( "mods/koira/files/biomes/darkness/darkness_layout_1.png", "mods/koira/files/biomes/darkness/darkness_visual.png", x, y, "mods/koira/files/biomes/darkness/darkness_background.png", true )
end

function spawn_corpse(x, y)
	function create_ragdoll(path)
	
		local ragdoll_id = EntityCreateNew()
		EntitySetTransform(ragdoll_id, x, y)
		
		EntityAddComponent(ragdoll_id, "DamageModelComponent", {
            hp="1",
            ragdoll_material="bone",
			ragdoll_filenames_file = path ,
			blood_material="blood",
			blood_spray_material="blood",
			ragdoll_offset_y = 0,
			ragdoll_offset_x = 0
		} )
		
		local ragdoll_damage_model_component = EntityGetFirstComponentIncludingDisabled(ragdoll_id, "DamageModelComponent")
		
		ComponentSetValue2(ragdoll_damage_model_component, "hp", 0)
		ComponentSetValue2(ragdoll_damage_model_component, "air_needed", true)
		ComponentSetValue2(ragdoll_damage_model_component, "air_in_lungs", 0)
	
	end
	
	SetRandomSeed( GameGetFrameNum(), x + y )
	local paths = { "data/ragdolls/failed_alchemist/filenames.txt", "data/ragdolls/failed_alchemist_b/filenames.txt", "data/ragdolls/enlightened_alchemist/filenames.txt" }
	local random_index = Random(1, #paths)
	local path = paths[random_index]
	create_ragdoll(path)
end

function spawn_air_blaster(x, y)
	EntityLoad( "mods/koira/files/weapons/air_blaster/gun.xml", x, y )
end

function spawn_items(x, y)
	EntityLoad( "data/entities/items/pickup/heart.xml", x, y )
end

function spawn_props( x, y )
	--EntityLoad( "data/entities/items/pickup/heart.xml", x+10, y )
	EntityLoad( "data/entities/items/pickup/heart_fullhp.xml", x, y )
end