dofile_once("mods/koira/files/scripts/utilities.lua")
dofile_once("mods/koira/files/scripts/globals.lua")

dofile_once("data/scripts/perks/perk.lua")


function change_altar_text(text)
  local altar = GetUpdatedEntityID()

  local interactableComponent = EntityGetFirstComponentIncludingDisabled(
    altar,
    "InteractableComponent"
  )

  ComponentSetValue2(interactableComponent, "ui_text", text)
end


function has_knife()
  return EntityGetName(get_active_wand()) == "knife"
end


function interacting(entity_who_interacted, entity_interacted, interactable_name)
  local altar_state = GlobalsGetValue(ALTAR_STATE)

  if altar_state == BeforeNightmares then
    nothing_to_see_here()
  elseif altar_state == AfterNightmares then
    get_us_a_knife()
  elseif altar_state == WithKnife then
    suffer()
  end
end


function nothing_to_see_here()
  GamePrint(GameTextGetTranslatedOrNot("$koira_altar_init"))
end


function get_us_a_knife()
  if has_knife() then
    change_altar_text("$koira_altar_interact2")
    GamePrintImportant(GameTextGetTranslatedOrNot("$koira_altar_dialogue1"), GameTextGetTranslatedOrNot("$koira_altar_dialogue2"))
    GlobalsSetValue(ALTAR_STATE, WithKnife)
    return
  end

  GamePrintImportant(GameTextGetTranslatedOrNot("$koira_altar_dialogue3"), "")
end


function suffer()
  if SUFFER_COUNT >= 13 then
    ritual_complete()
  end

  if not has_knife() then
    GamePrintImportant(GameTextGetTranslatedOrNot("$koira_altar_dialogue4"), "")
    return
  end

  player = get_player()
  local x, y = EntityGetTransform(player)

  GameCreateParticle("blood", x, y, 50, 80, -80, false)
  EntityInflictDamage(player, 0.01, "DAMAGE_CURSE", "dealing with the devil", "NORMAL", 5, 5, player, x, y, 0)
  SUFFER_COUNT = SUFFER_COUNT + 1
end


function ritual_complete()
  local altar = GetUpdatedEntityID()
  EntityKill(altar)

  GameScreenshake(50)

  GamePrintImportant(GameTextGetTranslatedOrNot("$koira_altar_dialogue5"), GameTextGetTranslatedOrNot("$koira_altar_dialogue6"))

  local x, y = EntityGetTransform(altar)
  local dj = perk_spawn(x-20, y, "DOUBLE_JUMP")
  local dash = perk_spawn(x+20, y, "DASH")

  -- FIXME ugly
  EntityAddComponent(dj, "VariableStorageComponent",
  {
    name = "perk_dont_remove_others",
    value_bool = "1",
  } )
  EntityAddComponent(dash, "VariableStorageComponent",
  {
    name = "perk_dont_remove_others",
    value_bool = "1",
  } )

  -- Change checkpoint location
  GlobalsSetValue(CURRENT_SPAWN, SpawnHiidenkivi)
  GlobalsSetValue("koira_ritual_complete", "1")
end
