dofile_once("mods/koira/files/scripts/utilities.lua")

function toggle_background(door)
  local bg = EntityGetFirstComponentIncludingDisabled(door, "SpriteComponent", "door_open_sprite")
  local enabled = ComponentGetIsEnabled(bg)

  EntitySetComponentIsEnabled(door, bg, not enabled)
end

function toggle_body(door)
  local body = EntityGetFirstComponentIncludingDisabled(door, "PhysicsBodyComponent")
  local enabled = ComponentGetIsEnabled(body)

  EntitySetComponentIsEnabled(door, body, not enabled)

  -- if enabled then
  --   for _, joint in ipairs(EntityGetComponent(door, "PhysicsJointComponent")) do
  --     EntityRemoveComponent(door, joint)
  --   end
  -- else
    EntityAddComponent(door, "PhysicsJointComponent", {
      ["nail_to_wall"] = 1, ["breakable"] = 1, ["grid_joint"] = 1, ["pos_y"] = 4
    })
    EntityAddComponent(door, "PhysicsJointComponent", {
      ["nail_to_wall"] = 1, ["breakable"] = 1, ["grid_joint"] = 1, ["pos_y"] = 15
    })
  -- end
end

function interacting(interacter, door, door_name)
  toggle_background(door)
  toggle_body(door)
end



-- Disable interacting when the door is shot, damaged anything
function physics_body_modified( is_destroyed )
  local door = GetUpdatedEntityID()
  local interaction = EntityGetFirstComponentIncludingDisabled(door, "InteractableComponent")
  local bg_sprite = EntityGetFirstComponentIncludingDisabled(door, "SpriteComponent", "door_bg_sprite")

  EntityRemoveComponent(door, interaction)
  EntityRemoveComponent(door, bg_sprite)
end

