dofile_once("mods/koira/files/coroutines.lua")
dofile_once("mods/koira/files/util.lua")
dofile_once("mods/koira/files/camera.lua")

local function get_player_position()
  local players = EntityGetWithTag("player_unit")
  if #players > 0 then
    return EntityGetTransform(players[1])
  end
end

async(function() 
  set_camera_manual(true)
  set_controls_enabled(false)
  local x, y = get_player_position()
  camera_set_position(x, y)
  

  camera_tracking_shot(x, y, 920, 99, 0.01)
  
  wait(40)
  local no_items = EntityGetWithTag("no_items")[1]
  EntityKill(no_items)
  
	function give_player_items(inventory, items)
	  for _, path in ipairs(items) do
		local item = EntityLoad(path)
		if item then
		  EntityAddChild(inventory, item)
		  EntitySetComponentsWithTagEnabled(item, "enabled_in_world", false)
		else
		  GamePrint("Couldn't load the item ["..path.."], something's terribly wrong!")
		end
	  end
	end
  
  local ITEMS_QUICK = {
    "mods/koira/files/items/bottled_rage/bottled_rage.xml"
  }
  GamePrintImportant(GameTextGetTranslatedOrNot("$koira_wake1"), GameTextGetTranslatedOrNot("$koira_wake2"))
  local inv_quick = EntityGetWithName("inventory_quick")
  give_player_items(inv_quick, ITEMS_QUICK)
  set_controls_enabled(true)
  
  local x, y = get_player_position()
  camera_tracking_shot(920, 99, x, y, 0.01)
  set_camera_manual(false)
  local entity_id = GetUpdatedEntityID()
  EntityKill(entity_id)
	  
end)

