dofile_once("data/scripts/lib/utilities.lua")

local max_range = 250
local min_range = 50

local entity_id = GetUpdatedEntityID()
local pos_x, pos_y = EntityGetTransform(entity_id)

local animal_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AnimalAIComponent")
local physics_body_component = EntityGetFirstComponentIncludingDisabled(entity_id, "PhysicsBodyComponent")
local physics_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "PhysicsAIComponent")

local function start_chase()
	-- enable chase & cell eater, disable this script
	  EntitySetComponentIsEnabled( entity_id, physics_ai_component, true )
	  EntitySetComponentIsEnabled( entity_id, physics_body_component, true )
	  EntitySetComponentIsEnabled( entity_id, animal_ai_component, true )
	  
	  EntitySetComponentIsEnabled( entity_id, GetUpdatedComponentID(), false )
end

local target = EntityGetClosestWithTag(pos_x, pos_y, "player_unit")
if not target or target == 0 then return end

local tx, ty = EntityGetTransform(target)
local dist = get_distance(tx, ty, pos_x, pos_y)
if dist > max_range then return end -- too far
if dist < max_range then
	-- very near
	start_chase()
	return
end

-- check los
local did_hit = RaytraceSurfaces(pos_x, pos_y, tx, ty)
if not did_hit then start_chase() end
