dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/koira/files/scripts/utilities.lua")
dofile_once("mods/koira/files/scripts/globals.lua")


local dog = GetUpdatedEntityID()
local dog_x, dog_y = EntityGetTransform(dog)

local bone = EntityGetWithName("the_bone")


-- Trigger for the_bone's LuaComponent
function throw_item(from_x, from_y, to_x, to_y)
  GamePrint("$koira_dog1")
  DOG_STATE = FollowBone
end
---


function dog_goto(x, y)
  local vel_x, vel_y = rad_to_vec(get_direction(dog_x, dog_y, x, y))

  local dog_data = EntityGetFirstComponent(dog, "CharacterDataComponent")
  ComponentSetValueVector2(dog_data, "mVelocity", vel_x*-200, 0)
end


function dog_pickup_bone(bone)
  EntitySetComponentsWithTagEnabled(dog, "fake_bone", true)
  EntityKill(bone)
end


function dog_drop_bone(bone)
  EntitySetComponentsWithTagEnabled(dog, "fake_bone", false)
  EntityLoad("mods/koira/files/items/the_bone/the_bone.xml", dog_x-12, dog_y)
end


function main()

  if DOG_STATE == FollowBone then
    if bone == nil or bone == 0 then
      DOG_STATE = DoNothing
    end

    local bone_x, bone_y = EntityGetTransform(bone)
    local distance = get_distance(dog_x, dog_y, bone_x, bone_y)

    if distance > 15 then
        dog_goto(bone_x, bone_y)
    else
      dog_pickup_bone(bone)
      DOG_STATE = BringBone
    end

  elseif DOG_STATE == BringBone then
    local px, py = EntityGetTransform(get_player())
    local p_distance = get_distance(dog_x, dog_y, px, py)

    if p_distance > 30 then
        dog_goto(px, py)
    else
      dog_drop_bone(bone)
      DOG_STATE = WaitForThrow
    end
  end

end


--GamePrint("Dog state is: ".. DOG_STATE)

main()
