dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/koira/files/scripts/utilities.lua")


function get_random_message()
  SetRandomSeed(666 * GameGetFrameNum(), GameGetFrameNum())
  local choices = {
    "$bottled_rage_prompt1",
    "$bottled_rage_prompt2",
    -- TODO: Expand this?
  }
  return choices[Random(1, #choices)]
end


function throw_item(from_x, from_y, to_x, to_y)
  -- Don't return if we were thrown out by death, respawn() will handle it.
  if (GlobalsGetValue("DEATH_IN_PROCESS") == "1") then return end

  -- TODO:
  -- Really build up for that spookiness
  SetTimeOut( 2, "mods/koira/files/items/bottled_rage/follow_player.lua", "start_following")
end


function start_following()
  local anger = EntityGetWithName("BOTTLED_FEELINGS")

  -- Cancel if the player already picked it up
  if (not item_in_inventory(anger)) then
    GamePrintImportant(get_random_message(), "")
    SetTimeOut(2, "mods/koira/files/items/bottled_rage/follow_player.lua", "jump_closer")
  end
end


function jump_closer()
  local anger = EntityGetWithName("BOTTLED_FEELINGS")
  local player = get_player()

  local anger_x, anger_y = EntityGetTransform(anger)
  local player_x, player_y = EntityGetTransform(player)

  local vel_x, vel_y = rad_to_vec(get_direction(anger_x, anger_y, player_x, player_y))

  local dist = get_distance(anger_x, anger_y, player_x, player_y)
  EntitySetTransform(anger, anger_x-vel_x*(dist/1.5), anger_y+vel_y*(dist/1.5))

  -- TODO: More sure way would be to check if anger is found in the inventory
  if (not item_in_inventory(anger)) then
    GameScreenshake( 20 )
    GamePlaySound(
      "data/audio/Desktop/projectiles.snd",
      "player_projectiles/tentacle_portal/create",
      anger_x, anger_y
    )

    SetTimeOut(1, "mods/koira/files/items/bottled_rage/follow_player.lua", "jump_closer")
  end
end
