dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/koira/files/scripts/gun_utilities.lua")


function _spawn_small_gun(roll, x, y)
  if roll <= 20 then
    spawn_gun("knife", x, y)
  elseif roll <= 40 then
    spawn_gun("spear", x, y)
  elseif roll <= 70 then
    spawn_gun("pistol", x, y)
  elseif roll <= 100 then
    spawn_gun("revolver", x, y)
  end
end


function _spawn_medium_gun(roll, x, y)
  if roll <= 25 then
    spawn_gun("smg", x, y)
  elseif roll <= 50 then
    spawn_gun("shotgun", x, y)
  elseif roll <= 75 then
    spawn_gun("assault_rifle", x, y)
  elseif roll <= 100 then
    spawn_gun("rifle", x, y)
  end
end


function _spawn_big_gun(roll, x, y)
  if roll <= 25 then
    spawn_gun("rocket_launcher", x, y)
  elseif roll <= 50 then
    spawn_gun("stakegun", x, y)
  elseif roll <= 75 then
    spawn_gun("grenade_launcher", x, y)
  elseif roll <= 100 then
    spawn_gun("flammenwerfer", x, y)
  end
end


function _spawn_energy_gun(roll, x, y)
  if roll <= 25 then
    spawn_gun("lightning_gun", x, y)
  elseif roll <= 60 then
    spawn_gun("railgun", x, y)
  elseif roll <= 100 then
    spawn_gun("plasmagun", x, y)
  end
end


function on_open(crate)
  local x, y = EntityGetTransform(crate)

  SetRandomSeed(GameGetFrameNum(), x + y + crate)
  local roll = Random(1,100)

  -- Offset for nicer spawn
  y = y - 5

  if EntityHasTag(crate, "crate_small") then
    _spawn_small_gun(roll, x, y)

  elseif EntityHasTag(crate, "crate_medium") then
    _spawn_medium_gun(roll, x, y)

  elseif EntityHasTag(crate, "crate_big") then
    _spawn_big_gun(roll, x, y)

  elseif EntityHasTag(crate, "crate_energy") then
    _spawn_energy_gun(roll, x, y)
  end


  -- TODO: Utilize this effect to make something badass
  EntityLoad("data/entities/particles/image_emitters/chest_effect_bad.xml", x, y)
end


---------------------------
-- Triggers

function item_pickup(crate, entity_who_picked, name)
  on_open(crate)
  EntityKill(crate)
end

function physics_body_modified(is_destroyed)
  local crate = GetUpdatedEntityID()

  on_open(crate)

  -- TODO: Test this
  edit_component( crate, "ItemComponent", function(comp,vars)
    EntitySetComponentIsEnabled(crate, comp, false)
  end)

  EntityKill(crate)
end

