dofile_once("mods/koira/files/scripts/utilities.lua")


function dash(player, onGround, dataComponent)
  local mouse_x, mouse_y = DEBUG_GetMouseWorld()
  local player_x, player_y = EntityGetTransform(player)

  local MAX_ENERGY = 100
  local COST = MAX_ENERGY*0.8

  local energy = ComponentGetValue2(dataComponent, "mFlyingTimeLeft")

  if (energy - COST < 0) then
    GamePrint("$koira_dash")
    return
  end

  local rotation = get_direction(mouse_x, mouse_y, player_x, player_y)
  local aim_x, aim_y = rad_to_vec(rotation)

  local going_up = rotation > unitCircle.topright and rotation < unitCircle.topleft
  local going_down = rotation > unitCircle.botleft and rotation < unitCircle.botright

  -- Going sideways, normal airdash
  local vel_x = aim_x*440
  local vel_y = -50

  if onGround then
    vel_x = aim_x*440
    vel_y = -85
  elseif going_up then
    -- Don't allow dashing to be used for gaining too much height
    vel_x = 0
    vel_y = -100
  elseif going_down then
    -- *But* we do want dashing to be powerful downwards, for smashing action.
    vel_x = aim_x*480
    vel_y = aim_y*-300
  end

  ComponentSetValue2(dataComponent, "mVelocity", vel_x, vel_y)
  ComponentSetValue2(dataComponent, "mFlyingTimeLeft", energy - COST)
  shoot_projectile(
    player,
    "mods/koira/files/weapons/dash/projectile/entity.xml",
    player_x, player_y,
    vel_x*0.5, vel_y*0.5
  )
end


function enable_kick(player, enable)
  EntitySetValue(player, "KickComponent", "can_kick", enable)
end
