
function extra_jump(dataComponent)
  local x, y = ComponentGetValue2(dataComponent, "mVelocity")

  -- Note: Add a slight horizontal boost aswell.
  ComponentSetValue2(dataComponent, "mVelocity", x*1.5, -120)
end


function jump_scaling(dataComponent, platComponent, framesInAir)
  -- Jump slightly higher the longer the "up" button is held.

  -- Always match the jump velocity set in XML:
  local vel_y = ComponentGetValue2(platComponent, "jump_velocity_y")
  local cur_x, cur_y = ComponentGetValue2(dataComponent, "mVelocity")

  -- Nice for debugging:
  --GamePrint("fia(" .. fia .. ") cur_y(" .. cur_y .. ")")

  -- Not perfect, but at least *slightly* nicer curve than just a flat `y`.
  local curve_y = math.min(math.cos(framesInAir/10)*vel_y, -70)
  ComponentSetValue2(dataComponent, "mVelocity", cur_x, curve_y)
end
