dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/koira/files/scripts/utilities.lua")

-- NOTICE!
-- This script is very performance-sensitive, best not to add any extra stuff here.

function draw_laser_sight(gun, show)
  -- Has to match the width of the sprite
  local SPRITE_PIXEL_LENGTH = 9

  -- Get coordinates of start and end points
  local gun_x, gun_y, rotation = EntityGetTransform(gun)
  local mouse_x, mouse_y = DEBUG_GetMouseWorld()

  -- Offset for a bit more accurate gun position
  gun_y = gun_y-1.75

  -- Get a visibility point, for cutting off the line. Essentially: "how far can we see".
  local did_hit, target_x, target_y = RaytracePlatforms(gun_x, gun_y, mouse_x, mouse_y)
  if (not did_hit) then
    target_x = mouse_x
    target_y = mouse_y
  end

  -- Set line length(x) and width(y)
  local length = -get_distance(gun_x, gun_y, target_x, target_y) / SPRITE_PIXEL_LENGTH
  local width = 0.15

  if not show then
    width = 0
    height = 0
  end

  local line_entity = EntityGetWithName("laser_sight")
  EntitySetTransform(line_entity, gun_x, gun_y, rotation, -length, width)
end
