dofile_once("mods/koira/files/scripts/utilities.lua")
dofile_once("mods/koira/files/scripts/gun_utilities.lua")


-- TODO PROBLEMS:
-- 1. The UI is not *always* updated in real-time if the player has inventory
-- open while picking up ammo from the world. Otherwise the "tiny hax" works great.
function move_mag_to_gun(magazine, player, magazine_name)
  local inventory = EntityGetWithName("inventory_quick")

  local action_id = ComponentGetValue2(
    EntityGetFirstComponent(magazine, "ItemActionComponent"), "action_id"
  )

  -- Scan all the guns in inventory, looking for the correct one.
  -- If nothing is found, then the ammo is added to the "FULL" inventory normally.
  for _, gun in ipairs(EntityGetAllChildren(inventory)) do
    if EntityHasTag(gun, action_id) then
      local max_mags = get_bandolier_size(gun)
      local current_mags = get_mags_left(gun)

      if current_mags < max_mags then
        -- Tiny hax: Make a copy of the magazine entity, because directly
        -- removing/setting parentage causes a weird CPP error.
        local magazine_copy = CreateItemActionEntity(action_id)

        -- Copy over the bullet count, so we can't throw down empty magazines
        -- and get back full ones.
        local item = EntityGetFirstComponent(magazine_copy, "ItemComponent")
        ComponentSetValue(item, "uses_remaining", get_bullets_left(magazine))

        -- Finally:
        --  * Get rid of the original picked up entity
        --  * Add the copy to the gun's inventory
        EntityKill(magazine)
        EntityAddChild(gun, magazine_copy)
      end
    end
  end

  -- HAX: Reset gun status. Effectively registering just added actions to the
  -- currently active gun. Really important!
  local inv2 = EntityGetFirstComponent(player, "Inventory2Component")
  if (inv2) then
    -- Refreshes current wand functionally
    ComponentSetValue2(inv2, "mActualActiveItem", 0)

    -- Refreshes the UI, if the player happens to have inventory open
    ComponentSetValue2(inv2, "mForceRefresh", true);
  end
end


function item_pickup(entity_item, entity_pickupper, item_name)
  if IsPlayer(entity_pickupper) then
    move_mag_to_gun(entity_item, entity_pickupper, item_name)
  end
end

