dofile_once("mods/koira/files/scripts/utilities.lua")


function draw_text(entity, text_string)
  local data = GlobalsGetValue(entity.."_debug_tag", "")
  if (data == "") then
      local textComponent = add_text(entity, text_string)
      GlobalsSetValue(entity.."_debug_tag", textComponent)
  else
      local textComponent = tonumber(data)
      ComponentSetValue2(textComponent, "text", text_string)
  end
end


function add_text(entity, text_string)
  local text = {
    font="data/fonts/font_pixel_white.xml",
    string=text_string,
    offset_x="0",
    offset_y="26",
    alpha="0.80",
    scale_x="0.7",
    scale_y="0.7"
  }
  text.offset_x = string.len(text.string)*1.9

  if (entity ~= nil) then
    local component = EntityAddComponent( entity, "SpriteComponent", {
        _tags = "enabled_in_world,speech_text",
        image_file = text.font or "data/fonts/font_pixel_white.xml",
        emissive = "1",
        is_text_sprite = "1",
        offset_x = text.offset_x or "0",
        offset_y = text.offset_y or "0",
        alpha = text.alpha or "1",
        update_transform = "1",
        update_transform_rotation = "0",
        text = text.string or "",
        has_special_scale = "1",
        special_scale_x = text.scale_x or "1",
        special_scale_y = text.scale_y or "1",
        z_index = "-9000"
      })
    return component
  end
end
