ModMaterialsFileAdd("mods/koira/files/materials.xml")
ModMagicNumbersFileAdd("mods/koira/files/magic_numbers.xml")
ModRegisterAudioEventMappings("mods/koira/files/audio/GUIDs.txt")

ModLuaFileAppend( "data/scripts/biome_scripts.lua", "mods/koira/files/scripts/biome_scripts.lua" )
-- Overwrite death sound to disable it
GamePlaySound("mods/koira/files/audio/death.bank", "dummy_sound", 0, 0)

ModLuaFileAppend("data/scripts/gun/gun_actions.lua", "mods/koira/files/actions.lua")
ModLuaFileAppend("data/scripts/status_effects/status_list.lua", "mods/koira/files/statuses.lua")
ModLuaFileAppend("data/scripts/perks/perk_list.lua", "mods/koira/files/perks.lua")

dofile_once("data/scripts/perks/perk.lua")
dofile_once("mods/koira/files/scripts/biome_utilities.lua")
dofile_once("mods/koira/files/scripts/death.lua")
dofile_once("mods/koira/files/scripts/utilities.lua")
dofile_once("mods/koira/files/scripts/gun_utilities.lua")
dofile_once("mods/koira/files/scripts/globals.lua")

local nxml = dofile_once("mods/koira/files/scripts/nxml.lua")

--set collapsed concrete strength
local content = ModTextFileGetContent("data/materials.xml")
local xml = nxml.parse(content)
for element in xml:each_child() do
  if element.attr.name == "rock_static_intro" then
    element.attr.durability = 99999999999999999999999
  end
end
ModTextFileSetContent("data/materials.xml", tostring(xml))

--Addition of custom translations
local content = ModTextFileGetContent("data/translations/common.csv")
ModTextFileSetContent("data/translations/common.csv", content .. [[
bottled_rage,Bottled Rage,Бутылочная ярость,,,,,,,,憤怒の小瓶,,,,
bottled_rage_desc,You can't keep burying it forever...,Вы не можете продолжать хоронить это вечно...,,,,,,,,いつまでも怒りを抑えることはできない。,,,,
bottled_rage_prompt1,WHAT DO YOU THINK YOU ARE DOING?...,"ЧТО, ПО-ТВОЕМУ, ТЫ ДЕЛАЕШЬ?...",,,,,,,,生意気な奴だ。,,,,
bottled_rage_prompt2,THERE IS NO RUNNING AWAY FROM ME...,ОТ МЕНЯ НЕ УБЕЖИШЬ...,,,,,,,,逃がさん。,,,,
koira_bed_name,A nice comfy bed,Хорошая удобная кровать,,,,,,,,ふかふかベッド,,,,
koira_bed_interact,Press $0 to go to sleep,"Нажмите $0, чтобы спать",,,,,,,,$0 を押して寝る,,,,
koira_dream_enter1,Suddenly,Внезапно,,,,,,,,夢,,,,
koira_dream_enter2,You feel powerful,Вы чувствуете себя сильным,,,,,,,,力が湧いてきた。,,,,
koira_dream_enter_prompt,going to sleep now,собираюсь спать,,,,,,,,就寝中…,,,,
koira_wake1,Your Dog,Ваша собака,,,,,,,,別れ,,,,
koira_wake2,Is Gone,Пропала,,,,,,,,愛犬を失った,,,,
koira_altar_name,Stone of the Hiisi,Камень Хииси,,,,,,,,ヒーシの魔石,,,,
koira_altar_interact,Press $0 to interact with the pedestal,Нажмите $0 для взаимодействия с постаментом,,,,,,,,$0 で祭壇を調べる,,,,
koira_altar_init,Not much to do here, just a peculiar rock formation.,Здесь особо нечего делать,,,,,,,奇妙な形の岩だ。,,,,
koira_altar_interact2,Press $0 to suffer,"Нажмите $0, чтобы страдать",,,,,,,,$0 で血を捧げる,,,,
koira_altar_dialogue1,GOOD,ОТЛИЧНО,,,,,,,,祭壇が血を求めている,,,,
koira_altar_dialogue2,now suffer,теперь страдайте,,,,,,,,血を捧げよ。,,,,
koira_altar_dialogue3,bring your knife,возьмите с собой нож,,,,,,,ナイフが必要だ。,,,,
koira_altar_dialogue4,You really need your knife for this,Для этого вам понадобится нож,,,,,,,,ナイフが必要だ。,,,,
koira_altar_dialogue5,EXCELLENT,ВЕЛИКОЛЕПНО,,,,,,,,力が与えられた,,,,
koira_altar_dialogue6,use them well,воспользуйся этим с умом,,,,,,,,これは便利そうだ。,,,,
koira_biome1,THE ENDLESS NIGHTMARES,БЕСКОНЕЧНЫЕ КОШМАРЫ,,,,,,,,終わりなき悪夢,,,,
koira_biome2,The Factory,Завод,,,,,,,,工場,,,,
koira_biome3,The Hiisi Farmlands,Фермерские угодья Хииси,,,,,,,,農場,,,,
koira_biome4,The Jungle,Джунгли,,,,,,,,ジャングル,,,,
koira_biome5,Home,Дом,,,,,,,,自宅,,,,
koira_biome6,The Hiisi Proto-Village,Протодеревня Хииси,,,,,,,,開拓中の村,,,,
koira_dog1,You threw the Bone! Heck!!!,Вы бросили кость! Апорт!!!,,,,,,,,ワンワン！,,,,
koira_bone_name,Bone,Кость,,,,,,,,ホネ,,,,
koira_bone_desc,Musti's favorite bone.,Любимая кость Мусти.,,,,,,,,愛犬が大好きなホネ,,,,
koira_ball_name,Ball,Мяч,,,,,,,,ボール,,,,
koira_ball_desc,A nice round ball.,Красивый круглый мячик.,,,,,,,,綺麗な丸をしている。,,,,
koira_grenade_name,Hand Grenades,Ручные гранаты,,,,,,,,手りゅう弾,,,,
koira_lantern_desc1,An Oil Lantern,Масляная лампа,,,,,,,,ランタン,,,,
koira_lantern_desc2,A Mining Lamp,Шахтёрская лампа,,,,,,,,鉱山用のランプ,,,,
koira_lantern_desc3,A Small Oil Lantern,Малая масляная лампа,,,,,,,,小さなオイルランプ,,,,
koira_custom_lantern,$0 Lantern,$0 лампа,,,,,,,,$0 ランタン,,,,
koira_mask_name1,Oddly familiar mask,Странно знакомая маска,,,,,,,,見覚えのある仮面,,,,
koira_mask_name2,Monkey mask,Маска обезьяны,,,,,,,,サルの仮面,,,,
koira_mask_name3,Robotic mask,Маска робота,,,,,,,,ロボの仮面,,,,
koira_painkillers,Painkillers,Болеутоляющие,,,,,,,,鎮痛剤,,,,
koira_crate1,Dangerous Arms Crate,Ящик с опасным оружием,,,,,,,,危険物の箱,,,,
koira_crate2,Electro-Arms Crate,Ящик с электрическим оружием,,,,,,,,電磁兵器の箱,,,,
koira_crate3,General-purpose Arms Crate,Ящик с оружием общего назначения,,,,,,,,汎用武器の箱,,,,
koira_crate4,Small Arms Crate,Ящик со стрелковым оружием,,,,,,,,小火器の箱,,,,
koira_dash,Not enough energy to dash!,Не хватает энергии для рывка!,,,,,,,,ダッシュエネルギーが足りない！,,,,
koira_respawn,welcome back,с возвращением,,,,,,,,帰還,,,,
koira_hatred_name,Hatred,Ненависть,,,,,,,,憎しみ,,,,
koira_hatred_desc,You are blinded by hatred,Вы ослеплены ненавистью,,,,,,,,憎しみに目が眩む。,,,,
koira_perk_name1,Lasersight Module,Модуль лазерного прицела,,,,,,,,レーザーサイト,,,,
koira_perk_desc1,Enables a helpful laser sight on a few select weapons that support it,"Включает полезный лазерный прицел на некоторых видах оружия, которые его поддерживают",,,,,,,,一部の武器でレーザーサイトが使えるようになる。,,,,
koira_perk_name2,Double Jump,Двойной прыжок,,,,,,,,2段ジャンプ,,,,
koira_perk_desc2,Allows you to jump again in air,Позволяет повторно подпрыгнуть в воздухе,,,,,,,,空中でもう1度ジャンプできるようになる。,,,,
koira_perk_name3,Dash-kick,Рывок-удар ногой,,,,,,,,ダッシュキック,,,,
koira_perk_desc3,Allows you perform powerful dashing action (kick while moving/jumping),Позволяет выполнять мощное действие во время рывка (пинок во время передвижения/прыжка).,,,,,,,,移動中、ジャンプ中にダッシュ攻撃を行えるようになる。,,,,
koira_liquid_hatred,Liquid Hatred,Жидкая ненависть,,,,,,,,憎しみの液体,,,,
koira_demon_blood,Demon Blood,Кровь демона,,,,,,,,悪魔の血,,,,
koira_knife,Knife,Нож,,,,,,,,ナイフ,,,,
koira_stab,Stab,Удар в спину,,,,,,,,槍,,,,
koira_stab_desc,Stick 'em with the pointy end, or just violently fling it at their general direction.,Затыкай их лезвием,,,,,,,,近接武器として使うもよし、投擲するもよし。,,,,
koira_switch,Switch,Переключатель,,,,,,,,スイッチ,,,,
koira_switch_interact,Press $0 to toggle power,Нажмите $0 для переключения питания,,,,,,,,$0 で切り替える,,,,
koira_door_name,Door,Дверь,,,,,,,,ドア,,,,
koira_door_interact,Press $0 to operate the door,"Нажмите $0, чтобы взаимодействовать с дверью",,,,,,,,$0 で開閉する,,,,
koira_hatch_name,Hatch,Люк,,,,,,,,ハッチ,,,,
koira_hatch_interact,Press $0 to operate hatch,"Нажмите $0, чтобы взаимодействовать с люком",,,,,,,,$0 で開閉する,,,,
koira_blinded_by_rage,Blinded by Rage,Ослеплённый яростью,,,,,,,,激怒,,,,
koira_gun_jam,For some odd reason your gun seems to jam,По какой-то странной причине ваше оружие заклинило,,,,,,,,銃が弾詰まりを起こしているようだ。,,,,
]])

-- Activate some basegame perks, without giving the player actual perk icons and all.
-- These are considered standard functionality in Koira.
  
local BASIC_FEATURES = {
  --"REPELLING_CAPE",  -- mighty bald head
  "EDIT_WANDS_EVERYWHERE",  -- move ammo between guns
  -- "PROTECTION_RADIOACTIVITY", -- personal grudge against toxic sludge
}

local STARTING_PERKS = {
  "LASERSIGHT",
  -- "DOUBLE_JUMP",
  -- "DASH",
}

local ITEMS_QUICK = {
  "mods/koira/files/items/bottled_rage/no_items.xml",
  "mods/koira/files/items/grenade/grenade.xml"
}
local ITEMS_FULL = {
}


function initGlobalState(player)
  GlobalsSetValue(CURRENT_SPAWN, SpawnBed)
  GlobalsSetValue(ALTAR_STATE, BeforeNightmares)
  EntitySetValue(player, "GenomeDataComponent", "herd_id", StringToHerdId("healer"))
end
function OnWorldPreUpdate()
	dofile("mods/koira/files/sleep/sleep_watcher.lua")
	
	local world_state_entity = GameGetWorldStateEntity()
	edit_component( world_state_entity, "WorldStateComponent", function(comp,vars)
		vars.time = 0
		vars.time_dt = 0
		-- vars.fog_target = 0
		-- vars.fog_target_extra = 0
	end)
end
function OnPlayerSpawned(player)
  if (GlobalsGetValue("FIRST_LOAD_DONE") == "1") then
    return
  end
  
  GlobalsSetValue("koira_lives", 5)
  GlobalsSetValue(CURRENT_SPAWN, SpawnBed)

  local x, y = EntityGetTransform(player)
  local inv_quick = EntityGetWithName("inventory_quick")
  local inv_full = EntityGetWithName("inventory_full")
  SetRandomSeed(x, y)

  -- Note: This is loaded here just to keep the entity in global namespace, for easy fetchability.
  EntityLoad("mods/koira/files/weapons/laser_sight.xml")

  enable_perks_without_icons(player, BASIC_FEATURES)
  enable_perks_without_icons(player, STARTING_PERKS)

  clear_player_inventory(player, inv_quick)
  give_player_items(inv_quick, ITEMS_QUICK)
  give_player_items(inv_full, ITEMS_FULL)

  set_time_of_day(0.4)

  initGlobalState(player)
  --
  -- TEMP DEBUGGING SPAWNS
  --
  give_player_gun("shotgun")
  give_player_gun("plasmagun")
  give_player_gun("chainsaw")
  give_player_gun("railgun")

  --EntityLoad("mods/koira/files/items/mask/chicken.xml", x+50, y)

  spawn_enemy("shepherd", x+100, y)
  --spawn_enemy("shepherd", x+100, y)
  --spawn_enemy("shepherd", x+100, y)
  -- Note: Hell ambience for hiidenkivi?

  GlobalsSetValue("FIRST_LOAD_DONE", "1")
end


function OnPlayerDied(player)
  -- TODO: Reserved for endgame.
end


function OnPausedChanged( is_paused, is_inventory_pause )
  -- TODO: For some reason this doesn't work. Can't kill entities just before pause?
  ammo_warning_display(false)
  mags_warning_display(false)
  gun_empty_warning_display(false)
end


--ModDevGenerateSpriteUVsForDirectory("data/enemies_gfx")

setting_cache = setting_cache or {}
local function get_setting(name)
    setting_cache[name] = setting_cache[name] or ModSettingGet(name)
    return setting_cache[name]
end

if get_setting("koira.shaders") then
	local contents = ModTextFileGetContent("mods/koira/files/shaders/post_final.frag")
	ModTextFileSetContent("data/shaders/post_final.frag", contents)

	local contents = ModTextFileGetContent("mods/koira/files/shaders/sprite_damage_highlight.frag")
	ModTextFileSetContent("data/shaders/sprite_damage_highlight.frag", contents)
end
