dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

local projectiles = EntityGetWithTag( "projectile" )
local direction_random = math.rad( Random( -30, 30 ) )


-- TODO move elsewhere
function dump(o)
   if type(o) == 'table' then
      local s = '{ '
      for k,v in pairs(o) do
         if type(k) ~= 'number' then k = '"'..k..'"' end
         s = s .. '['..k..'] = ' .. dump(v) .. ','
      end
      return s .. '} '
   else
      return tostring(o)
   end
end

if ( #projectiles > 0 ) then
  for i,projectile_id in ipairs(projectiles) do	
    local px, py = EntityGetTransform( projectile_id )

    local distance = math.abs( x - px ) + math.abs( y - py )
    local distance_full = 100 --here


    -- TODO! This had a chance of being "0" for tentacle portal thingy. Does it still?
    local projectile_component = EntityGetFirstComponentIncludingDisabled(projectile_id, "ProjectileComponent")
    local who_shot = ComponentGetValue( projectile_component, "mWhoShot")


    -- TODO: Fix this possible crash, in case no players are returned.
    local player_entity = get_players()[1]
    local player_x, player_y = EntityGetTransform( player_entity )


    -- TODO: CHECK THIS FOKKIN PAUSE
    --script_wait_frames( "whatever", 20 )

    -- TODO: add back player_aim_direction" )
    local player_projectiles = EntityGetWithTag("gust_player")
    --local velocity_player_projectile = EntityGetFirstComponent(player_projectiles[1], "VelocityComponent" )
    local aim_x, aim_y = GameGetVelocityCompVelocity(player_projectiles[1])
    --local aim_x, aim_y = ComponentGetValueVector2(player_shooter, "mSmoothedAimingVector")



    local player_shooter = EntityGetFirstComponent(player_entity, "PlatformShooterPlayerComponent") 

    if ( not IsPlayer(who_shot) and distance < distance_full * 1.25 ) then

      -- TODO: Check which one of these can be discarded
      ComponentSetValue( projectile_component, "friendly_fire", "1")
      ComponentSetValue( projectile_component, "collide_with_shooter_frames", "1")
      ComponentSetValue( projectile_component, "collide_with_tag", "mortal")

      distance = get_distance( px, py, x, y )
      direction = get_direction( px, py, x, y )

      if ( distance < distance_full ) then
        local velocitycomponents = EntityGetComponent( projectile_id, "VelocityComponent" )

        local gravity_percent = math.max(( distance_full - distance ) / distance_full, 0.01)
        local gravity_coeff = 156

        if ( velocitycomponents ~= nil ) then
          edit_component( projectile_id, "VelocityComponent", function(comp,vars)
            local vel_x,vel_y = ComponentGetValueVector2( comp, "mVelocity", vel_x, vel_y)

            local offset_x = math.cos( direction + direction_random ) * ( gravity_coeff * gravity_percent )
            local offset_y = 0 - math.sin( direction + direction_random ) * ( gravity_coeff * gravity_percent )

            vel_x = vel_x --+ aim_x --*1.5 --+ offset_x
            vel_y = vel_y --+ aim_y --*1.5 --+ offset_y

            ComponentSetValueVector2( comp, "mVelocity", aim_x, aim_y)
          end)
        end
      end
    end
  end
end
